#include <iostream>
#include <vector>
#include <algorithm>

int podela_takmicara(std::vector<int> rejtinzi) 
{
    // Sortiramo niz rejtinga takmicara
    std::sort(rejtinzi.begin(), rejtinzi.end());

    int n = rejtinzi.size();
    int j, k, broj_timova = 0;

    // Fiksiramo svaki od rejtinga i prolazimo kroz niz ostalih rejtinga gde proveravamo da li postoje jos neka 2, tako da sa fiksiranim
    // rejtingom, svi u zbiru daju 0
    for (int i = 0; i < n; i++) {
        // Iskljucujemo trenutno fiksirani rejting, pa zato idemo od i + 1
        j = i + 1;
        // Poslednji validni indeks u nizu je n - 1, tj desni pokazivac krece od poslednjeg rejtinga
        k = n - 1;

        // Dok god se pokazivaci ne susretnu (ne razmatramo slucaj j == k, jer ne moze jedan takmicar u 2 tima da se smesti)
        while (j < k) {
            // Ako je zbir rejtinga koje razmatramo veci od 0, znaci da treba smanjiti zbir. Kako je niz sortiran, treba uzeti manji broj
            // a manji brojevi su levo od onog na poziciji k
            if (rejtinzi[i] + rejtinzi[j] + rejtinzi[k] > 0) {
                k--;
            }
            // Ako je zbir rejtinga koje razmatramo manji od 0, znaci da treba povecati zbir. Kako je niz sortiran, treba uzeti veci broj
            // a veci brojevi su desno od onog na poziciji j
            else if (rejtinzi[i] + rejtinzi[j] + rejtinzi[k] < 0) {
                j++;
            }
            // Ako zbir nije ni manji ni veci od 0, jedina preostala solucija je da je jednak 0, tako da pomeramo oba indeska levo i desno
            // i povecavamo broj kreiranih timova za 1. Pomeramo oba indeksa jer je moguce da ovo nije jedina kombinacija za fiksirani element
            // na poziciji i. Kako pomeramo levi pokazivac desno, povecavaju se brojevi, a kako pomeramo desni pokoazivac levo, brojevi se smanjuju
            // Razmotrimo primer 1,3,5,8,13,15. Neka je trazeni zbir 16. Imamo kombinaciju 1 + 15, ali i 3 + 13. Ako ne bismo nastavili pretragu nakon
            // sto jednom nadjemo zbir koji je 0, ne bismo nasli nikada kombinaciju 3 + 13  
            else {
                j++;
                k--;
                broj_timova++;
            }
        }
    }

    return broj_timova;
}

int main ()
{
    std::vector<int> rejtinzi = {-8, -5, 7, 4, 1, -2, 9, -3, 2};

    std::cout << podela_takmicara(rejtinzi) << "\n";

    return 0;
}