#include <iostream>
#include <vector>

void segmenti_zbira(const std::vector<int> &niz, int trazeni_zbir) {
    // Oba pokazivaca na pocetku stavljamo na 0 jer ovde zelimo da uzmemo u obzir i jednoclane segmente
    int i = 0;
    int j = 0;
    // Trenutni zbir koji razmatramo u intervalu [0, 0] je bas taj jedan jedini element
    int zbir = niz[0];
    // Duzinu niza cuvamo radi efikasnosti
    int n = niz.size();

    // Dok god nam je desni pokazivac unutar granica niza, krecemo se
    while (j < n) {
        // Ako je trenutni zbir manji od trazenog, treba ga povecati na neki nacin
        // Znamo da su svi brojevi pozitivni (uslov zadatka), pa cemo pomeranjem pokazivaca j sigurno povecati ukupnu vrednost zbira u 
        // segmentu. Mi cemo tako zapravo prosiriti sam segment za jos jedan element (sigurno pozitivan), i na taj nacin povecati ukupnu
        // sumu segmenta [i, j].
        if (zbir < trazeni_zbir) {
            // Azuriramo pokazivac
            j++;
            // Povecavamo zbir za odgovarajucu vrednost. Ovo je novootkrivena vrednost. Do sad nismo znali da ovaj broj postoji, ali kako
            // smo se pomerili za jedno mesto desno, otkrili smo novi broj i njega dodali na ukupan zbir u segmentu (i povecali segment
            // istovremeno)
            zbir += niz[j];
        }
        // Ako zbir nije manji od trazenog, jednak je ili veci
        else {
            // Ako je bas jednak ispisujemo samo indekse pocetka i kraja odgovarajuceg segmenta
            if (zbir == trazeni_zbir) {
                std::cout << i << " " << j << "\n";
            }

            // Ako se desi da je zbir veci od trazenog, treba ga smanjiti. To se moze postici pomeranjem levog indeks u desnu stranu,
            // jer na taj nacin izbacujemo jedan element iz segmenta i samim tim zbir u segmentu pada (brojevi su pozitivni)
            i++;
            // Umannjujemo vrednost zbira
            zbir -= niz[i];
        }
    }
}

int main ()
{
    std::vector<int> niz = {1, 2, 3, 5, 15, 1, 2, 5};

    segmenti_zbira(niz, 21);

    return 0;
}